//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Interop.Client.RecoverableErrorProvider.RecoverableErrorProvider
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Raise Recoverable Error command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class RaiseRecoverableErrorRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.IntegerDto _durationUntilError;
        
        private Tecan.Sila2.IntegerDto _automaticExecutionTimeout;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public RaiseRecoverableErrorRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="durationUntilError">The duration in seconds before the recoverable error is raised.</param>
        /// <param name="automaticExecutionTimeout">The duration in seconds after the specified default option is automatically selected (0 means no automatic execution).</param>
        public RaiseRecoverableErrorRequestDto(long durationUntilError, long automaticExecutionTimeout, Tecan.Sila2.IBinaryStore store)
        {
            DurationUntilError = new Tecan.Sila2.IntegerDto(durationUntilError, store);
            AutomaticExecutionTimeout = new Tecan.Sila2.IntegerDto(automaticExecutionTimeout, store);
        }
        
        /// <summary>
        /// The duration in seconds before the recoverable error is raised.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.IntegerDto DurationUntilError
        {
            get
            {
                return _durationUntilError;
            }
            set
            {
                _durationUntilError = value;
            }
        }
        
        /// <summary>
        /// The duration in seconds after the specified default option is automatically selected (0 means no automatic execution).
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.IntegerDto AutomaticExecutionTimeout
        {
            get
            {
                return _automaticExecutionTimeout;
            }
            set
            {
                _automaticExecutionTimeout = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/RecoverableErrorProvider/v1/Command/RaiseRecoverableError";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(DurationUntilError, "durationUntilError");
            if ((DurationUntilError.Value < 0))
            {
                throw new ArgumentException(string.Format("DurationUntilError should have been at least 0 but was \'{0}\'", DurationUntilError.Value), "durationUntilError");
            }
            Argument.Validate(AutomaticExecutionTimeout, "automaticExecutionTimeout");
            if ((AutomaticExecutionTimeout.Value < 0))
            {
                throw new ArgumentException(string.Format("AutomaticExecutionTimeout should have been at least 0 but was \'{0}\'", AutomaticExecutionTimeout.Value), "automaticExecutionTimeout");
            }
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = (("" + Argument.Require(DurationUntilError, "durationUntilError")) 
                        + Argument.Require(AutomaticExecutionTimeout, "automaticExecutionTimeout"));
            if ((DurationUntilError.Value < 0))
            {
                errors = (errors + string.Format("DurationUntilError should have been at least 0 but was \'{0}\'", DurationUntilError.Value));
            }
            if ((AutomaticExecutionTimeout.Value < 0))
            {
                errors = (errors + string.Format("AutomaticExecutionTimeout should have been at least 0 but was \'{0}\'", AutomaticExecutionTimeout.Value));
            }
            return errors;
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Raise Recoverable Error command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class RaiseRecoverableErrorResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.StringDto _selectedContinuationOption;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public RaiseRecoverableErrorResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="selectedContinuationOption">The identifier of the continuation option which has been selected to handle the error.</param>
        public RaiseRecoverableErrorResponseDto(string selectedContinuationOption, Tecan.Sila2.IBinaryStore store)
        {
            SelectedContinuationOption = new Tecan.Sila2.StringDto(selectedContinuationOption, store);
        }
        
        /// <summary>
        /// The identifier of the continuation option which has been selected to handle the error.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto SelectedContinuationOption
        {
            get
            {
                return _selectedContinuationOption;
            }
            set
            {
                _selectedContinuationOption = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(SelectedContinuationOption, "selectedContinuationOption");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(SelectedContinuationOption, "selectedContinuationOption"));
        }
    }
}
